c                                                 21.01.2004
c
c         The program of calculation of volume percentage
c         for CONNECTIVITY ANALISIS
c         according to part of volume per one residue
c
          nudat=7
          nuprot=8
          pi=3.1415927
          reclev=0.
c
          call rddat(nudat,nuprot,acell,bcell,ccell,
     *      alfa,beta,gamma,nres,nmol,step,nstep)
ccccccccccccccccccccccccccccccccccccccccccc
          arad=alfa*pi/180.
          brad=beta*pi/180.
          grad=gamma*pi/180.
          ca=cos(arad)
          cb=cos(brad)
          cg=cos(grad)
          sa=sin(arad)
          sb=sin(brad)
          sg=sin(grad)
          w=sqrt(1-ca*ca-cb*cb-cg*cg+2*ca*cb*cg)
          cappa=1-ca*ca-cb*cb-cg*cg+2*ca*cb*cg
          ww=acell*bcell*ccell*cappa
          if (ww.eq.0) stop 'Wrong unit cell parameters'
          vol=acell*bcell*ccell*w
ccccccccccccccccccccccccccccccccccccccccccc
          w=nres*nmol*step/vol
          write(nuprot,'(/1x,a32/1x,a38)')
     *          '  cut_off level         vol./res',
     *          '(relitive volume) (in cubic Angstroms)'
          do i=1,nstep
             p=1.*i
             a=step*p
             u=w*p
             write(nuprot,'(3x,f10.6,11x,f8.4)') u,a
             if (a.eq.25.) reclev=u
          end do
          if (reclev.ne.0.) write (nuprot,'(/a28,f4.2)')
     *        ' Recommended cut-off level: ',reclev
          stop
          end
         subroutine rddat(nudat,nuprot,acell,bcell,ccell,
     *      alfa,beta,gamma,nres,nmol,step,nstep)
         character inps*72
c
          nu2=20
          open(nudat,file='level.dat')
          open(nuprot,file='level.mes')
          open(nu2,status='scratch')
10        continue
          read (nudat,'(a72)',end=20) inps
          if (inps(1:1).ne.'!') write (nu2,'(a72)') inps
          goto 10
20        continue
          close(nudat)
          rewind(nu2)
          nudat=nu2
c
          write(nuprot,'(10x,a37/)')
     *          'LEVEL                      21.01.2004'
          write(nuprot,'((1x,a47))')
     *         'The program of calculation of volume percentage',
     *         '           for CONNECTIVITY ANALISIS           ',
     *         '  according to part of volume per one residue  '
          read (nudat,*,end=100) acell,bcell,ccell,alfa,beta,gamma
          write(nuprot,'(/1x,a11,6f8.2)')
     *     'Unit cell: ',acell,bcell,ccell,alfa,beta,gamma
          read (nudat,*,end=100) nres
          write(nuprot,'(1x,a21,i6)')   'number of residues : ',nres
          read (nudat,*,end=100) nmol
          write(nuprot,'(1x,a21,i6)')   'number of molecules: ',nmol
          read (nudat,*,end=100) step
          write(nuprot,'(1x,a21,f6.2)') 'step (in vol/res.) : ',step
          read (nudat,*,end=100) nstep
          write(nuprot,'(1x,a21,i6)')   'number of steps    : ',nstep
         return
100      continue
         stop 'Invalid input data'
         end